/*
 *  linux/init/config.c
 *
 *  Copyright (C) 1993, Hamish Macdonald
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file README.legal in the main directory of this archive
 * for more details.
 */

#include <linux/config.h>
#include <linux/types.h>
#include <linux/bootinfo.h>
#include <linux/fs.h>
#include <linux/kernel.h>
#include <linux/tty.h>
#include <linux/console.h>

#ifdef CONFIG_AMIGA
#include <linux/amigaconf.h>
#endif
#ifdef CONFIG_ATARI
#include <linux/atariconf.h>
#endif
#ifdef CONFIG_MAC
#include <linux/macconf.h>
#endif


void (*mach_sched_init) (isrfunc);
unsigned long (*mach_keyb_init) (unsigned long);
void (*mach_init_INTS) (void);
int (*mach_add_isr) (unsigned long, isrfunc, int, void *);
unsigned long (*mach_gettimeoffset) (void);
void (*mach_gettod) (struct mktime*);
void (*mach_check_partition) (struct gendisk *, unsigned int);

void config_init(void)
{
	switch (boot_info.machtype) {
#ifdef CONFIG_AMIGA
	    case MACH_AMIGA:
		config_amiga();
		break;
#endif
#ifdef CONFIG_ATARI
	    case MACH_ATARI:
		config_atari();
		break;
#endif
#ifdef CONFIG_MAC
	    case MACH_MAC:
		config_mac();
		break;
#endif
	    default:
		panic ("No configuration setup");
	}
}
