#ifndef A2091_H

/* $Id$
 *
 * Header file for the Commodore A2091 Zorro II SCSI controller for Linux
 *
 * Written and (C) 1993, Hamish Macdonald, see a2091.c for more info
 *
 */

#include <linux/types.h>

int a2091_detect(int);
const char *wd33c93_info(void);
int wd33c93_command(Scsi_Cmnd *);
int wd33c93_queuecommand(Scsi_Cmnd *, void (*done)(Scsi_Cmnd *));
int wd33c93_abort(Scsi_Cmnd *, int);
int wd33c93_reset(Scsi_Cmnd *);

#ifndef NULL
#define NULL 0
#endif

#define A2091_SCSI {"Commodore A2091 SCSI controller",	\
		    a2091_detect,			\
		    wd33c93_info,			\
		    wd33c93_command,			\
		    wd33c93_queuecommand,		\
		    wd33c93_abort,			\
		    wd33c93_reset,			\
		    NULL, NULL,				\
		    1, 7, SG_NONE, 1, 0, 0}

#endif /* A2091_H */
