/*
 * Originaly from:
 *
 * Mach Operating System
 * Copyright (c) 1992 Carnegie Mellon University
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */

/*
 * This file describes the layout of a GVP series II SCSI controller
 * (product 11) as understood by Niklas Hallqvist (niklas@appli.se).
 * Note: this info is not hard facts, but rather guesses.
 *
 * Modified for Amiga Linux by Ralf B?chle
 */

#define v_char		volatile char
#define	v_int		volatile int
#define vu_char		volatile u_char
#define vu_short	volatile u_short
#define vu_int		volatile u_int

struct sdmac {
  vu_short ________________pad0[32];
  vu_short control;
  vu_short ________________pad1[15];
  vu_char  ________________pad2;
  vu_char  wd_address;
  vu_char  ________________pad3;
  vu_char  wd_data;
  vu_short ________________pad4[2];
  vu_short bank;
  vu_short ________________pad5[3];
  vu_int   DMA_address;
  vu_short secret1;	/* Initially store 0  here */
  vu_short start_DMA;	/* strobe */
  vu_short stop_DMA;	/* strobe */
  vu_short secret2;	/* Initially store 1  here */
  vu_short secret3;	/*         "       15  "   */
};

/* bits in `control' */
#define GVP11_DMAC_BUSY		(1<<0)
#define GVP11_DMAC_INT_PENDING	(1<<1)
#define GVP11_DMAC_INT_ENABLE	(1<<3)
#define GVP11_DMAC_DIR_WRITE	(1<<4)
