/*
 *  linux/include/linux/amigaconf.h
 *
 *  Copyright (C) 1993        Hamish Macdonald
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file README.legal in the main directory of this archive
 * for more details.
 */

#ifndef _LINUX_AMIGACONF_H_
#define _LINUX_AMIGACONF_H_ 1

#include <linux/amigahw.h>

extern void amiga_sched_init(isrfunc);
extern unsigned long amiga_keyb_init(unsigned long);
extern void amiga_init_INTS (void);
extern int amiga_add_isr (unsigned long, isrfunc, int, void *);
extern unsigned long amiga_gettimeoffset (void);
extern void a3000_gettod (struct mktime *);
extern void a2000_gettod (struct mktime *);
extern void amiga_check_partition (struct gendisk *hd, unsigned int dev);
extern struct consw ami_con;

static __inline void config_amiga(void)
{
    mach_sched_init      = amiga_sched_init;
    mach_keyb_init       = amiga_keyb_init;
    mach_init_INTS       = amiga_init_INTS;
    mach_add_isr         = amiga_add_isr;
    mach_gettimeoffset   = amiga_gettimeoffset;
    if (boot_info.bi_amiga.model == AMI_3000
	|| boot_info.bi_amiga.model == AMI_4000)
	    mach_gettod          = a3000_gettod;
    else
	    mach_gettod          = a2000_gettod;
    mach_check_partition = amiga_check_partition;
    conswitchp	       = &ami_con;

#if 0
    /* set up hardware bases */
    CustomBase = (caddr_t)CUSTOM_PHYSADDR;
    CiaABase   = (caddr_t)CIAA_PHYSADDR;
    CiaBBase   = (caddr_t)CIAB_PHYSADDR;
#endif

    /* clear all DMA bits */
    custom.dmacon = DMAF_ALL;
    /* ensure that the DMA master bit is set */
    custom.dmacon = DMAF_SETCLR | DMAF_MASTER;

    /*
     * if it is an A3000, set the magic bit that forces
     * a hard rekick
     */
    if (boot_info.bi_amiga.model == AMI_3000)
	    *(u_char *)0xde0002 |= 0x80;
}

#endif /* linux/amigaconf.h */
