/*
 *  linux/include/linux/config.h
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file README.legal in the main directory of this archive
 * for more details.
 */

#ifndef _LINUX_CONFIG_H
#define _LINUX_CONFIG_H

#include <linux/autoconf.h>

/*
 * Defines for what uname() should return
 */
#ifndef UTS_SYSNAME
#define UTS_SYSNAME "Linux/68k"
#endif

#ifndef UTS_NODENAME
#define UTS_NODENAME "(none)"   /* set by sethostname() */
#endif

#ifndef UTS_MACHINE
#define UTS_MACHINE "m68k"     /* hardware type */
#endif

#ifndef UTS_DOMAINNAME
#define UTS_DOMAINNAME "(none)" /* set by setdomainname() */
#endif


/*
 * The definitions for UTS_RELEASE and UTS_VERSION are now defined
 * in linux/version.h, and should only be used by linux/version.c
 */

/* interrupt service routine function ptr type */
struct intframe;
typedef void (*isrfunc) (struct intframe *fp, void *data);

extern void (*mach_sched_init) (isrfunc);
extern unsigned long (*mach_keyb_init) (unsigned long);
extern void (*mach_init_INTS) (void);
extern int (*mach_add_isr) (unsigned long source, isrfunc isr,
			    int pri, void *data);
extern unsigned long (*mach_gettimeoffset)(void);
struct mktime;
extern void (*mach_gettod)(struct mktime*);
struct gendisk;
extern void (*mach_check_partition) (struct gendisk *hd, unsigned int dev);

#endif /* linux/config.h */
